# AGPLv3-or later

# This plugin renders the current petition on every page.

PluginData = {"author":{
        "title":"Blender Dumbass",
        "url":"https://blenderdumbass.org",
        "avatar":"https://blenderdumbass.org/pictures/favicon.png"
    },
              "title":"Active Petition",
              "description":"Show the active petition on every page on the bottom.",
              "license":"AGPL-3.0-or-later"}

from modules import Render

def onHTML(server, html):

    articles = Render.allArticles()
    petition = None
    for i in articles:
        if articles[i].get("petition", {}):
            if articles[i]["petition"].get("goal", 0) > articles[i]["petition"].get("signed", 0):
                petition = articles[i]
                break

    if petition and "login" not in server.path:

        frac = min(1, articles[i]["petition"].get("signed", 0) / articles[i]["petition"].get("goal", 0) )

        left = articles[i]["petition"].get("goal", 0) - articles[i]["petition"].get("signed", 0)
        
        html = html + """
        
        </div></div></div></div></center>
        

        <style>
        
        .petition_box {
        
        position: fixed;
        width:100%;
        left:0;
        bottom: 0;
        
        }
        
        .petition_padding {

        position: relative;
        height:500px;
        bottom: 0;

        }


        </style>
        

        <div class="petition_box">

        <details open>
        <summary>Show / Hide</summary>
        
        <div class="dark_box" style="width=100%">
        
        <a href=\""""+petition.get("url", "")+"""">
        Petition to """+petition.get("title","Petition")+"""</a>
        
        We need just """+str(left)+""" more signatures. Please sign!
        
        <br><br>
        """+Render.ProgressBar(frac)+"""
        
        
        </details>
        
        </div>

        </div>


        """
        html = html.replace('</div><div class="checklist_section_article">',
                            '<div class="petition_padding"><br><br><br><br><br></div></div><div class="checklist_section_article">')

        html = html.replace("<!-- /Render.Footer -->","<br><br><br><br><br>")
        
    return html
